from django.dispatch import receiver
from django.db.models.signals import post_save

from .models import User, Corporation, Adhesion


@receiver(post_save, sender=User, dispatch_uid='create_user_adhesion')
def create_user_adhesion(sender, instance, created, **kwargs):
    if created:
        Adhesion.objects.create(user=instance)


@receiver(post_save, sender=Corporation, dispatch_uid='create_corporation_adhesion')
def create_corporation_adhesion(sender, instance, created, **kwargs):
    if created:
        Adhesion.objects.create(corporation=instance)
